Subject: Re: [PATCH] Add firmware label support to iproute2

From: Stephen Hemminger <[email-masked]>
Date: Thu, 19 Aug 2010 14:53:08 -0700

On Thu, 19 Aug 2010 16:33:14 -0500
Matt Domsch <[email-masked]> wrote:

> On Wed, Aug 18, 2010 at 02:41:24PM -0700, Stephen Hemminger wrote:
> > The netdev_alias_to_kernelname should only happen after normal lookup failed.
> 
> Stephen, can you enlighten me as to the "right" way to do interface
> name lookups?  While I can still find examples of parsing
> /proc/net/dev, or globbing /sys/class/net/*, I expect these aren't the
> preferred method anymore.  Your own iproute2 suite uses RTM_GETLINK
> netlink calls, though for the seeming simple case of "give me a list of all
> interfaces", your path through there is far more capable (and
> complex) than I would hope to need.

There is no magic right way. We have to support multiple interfaces.
I am really concerned that all this alias stuff will turn into a
disaster when there are 10,000 interfaces (Vlans).  The kernel has
lots of tables and hashes to handle this but if the utilities
are doing a dumb scan of all names it will not work.

Also burying logic in an external library seems problematic as
well. The original sysfs library was a disaster for this.
I want this to work but it has to have a simple interface that
is not trying to hide things.